
import java.io.*;

public class JIndexer {

   private static void usage() {
       System.out.println("JIndexer 0.1 by Airex");
       System.out.println("Usage:");
       System.out.println("<your_java_cmdline> JIndexer -s <string_to_search>");
       System.out.println(" Return a list of <disc/drive name>:<path> of file matching <string_to_search>");
       System.out.println("<your_java_cmdline> JIndexer -i <disc/drive name> <path>");
       System.out.println(" Create the index for <path> in <disc/drive name>");
       System.out.println("Samples:");
       System.out.println("java -cp classes JIndexer -s util_file.tar.gz");
       System.out.println("java -cp classes JIndexer -i DVD_Progs_1 E:\\");
       System.out.println("java -cp classes JIndexer -i DVD_Progs_1 /mnt/dvd_rom");
   }


   public static void main (String[] args) {
      if ( args.length > 3 || args.length < 2 ||
           (!args[0].equals("-s") && !args[0].equals("-i"))
          ) {
          usage();
          return;
      }
      if (args[0].equals("-s") && args.length != 2) {
          usage();
          return;
      }
      if (args[0].equals("-i") && args.length != 3) {
          usage();
          return;
      }
      if (args[0].equals("-s")) {
         System.out.println("Searching '"+args[1]+"'");
         File [] indexes = new File("indexes/").listFiles();
         for (int i=0;i<indexes.length;i++) {
            String buffer = "";
            int ch;
            try {
               System.out.println("Reading "+indexes[i]);
               long tot = indexes[i].length();
               long cur = 0;
               BufferedReader br = new BufferedReader(new FileReader(indexes[i]));
               if ((int)tot == tot) {
                 char [] chrs = new char [(int)tot];
                 br.read(chrs,0,(int)tot);
                 buffer = String.copyValueOf(chrs);
               }
               else {
                 long read_ok = 0;
                 int incr = (int)tot;
                 while (read_ok != tot) {
                    if ((tot - read_ok)<incr)
                       incr = (int)(tot - read_ok);
                    char [] chrs = new char [incr];
                    br.read(chrs,0,incr);
                    buffer = buffer + String.copyValueOf(chrs);
                    read_ok += incr;
                 }
               }
                String [] buffs = buffer.split("\n");
                for (int k=0;k<buffs.length;k++)
                  if (buffs[k].toUpperCase().indexOf(args[1].toUpperCase())>0)
                     System.out.println("=>"+indexes[i].getName()+": "+buffs[k]);
                br.close();
            }
            catch (Exception ex) {
               System.out.println("Error:Unable to get info from "+indexes[i].getName());
            }
         }
      }
      else
      if (args[0].equals("-i")) {
         String name = args[1];
         String path = args[2];
         String flist = "";
         try {
             flist = list_dir(path);
         }
         catch (Exception ex) {
             System.out.println("Error:Unable to get file list from "+path);
         }
         try {
             File f = new File("indexes/"+name);
             BufferedWriter bw = new BufferedWriter( new FileWriter( f ) );
             bw.write( flist );
             bw.flush();
             bw.close();
         }
         catch (Exception ex) {
           System.out.println("Error:Unable to write indexes/"+name);
         }
      }
   }

   private static String list_dir(String dirname) {
       String ret = "";
       File f;
       File [] fl;
       f = new File (dirname);
       fl = f.listFiles();
       for (int i=0;i<fl.length;i++) {
         String ret_ric = "";
         ret = ret + fl[i].toString() + "\n";
         if (fl[i].isDirectory())
            ret_ric = list_dir(fl[i].toString());
         ret = ret + ret_ric;
       }
       return ret;
   }



}